#ifndef _ERROR_H
#define _ERROR_H 1

/* Print a message with |fprintf(stderr, format, ...);| if |errnum| is
   nonzero, follow it with ": " and |strerror(errnum)|.  If |status|
   is nonzero, terminate the program with |exit(status)|.  */

extern void error(int __status, int __errnum, const char *__format, ...);

extern void error_at_line(int __status, int __errnum, const char *__fname,
                          unsigned int __lineno, const char *__format, ...);

/* If |NULL|, error will flush |stdout|, then print on |stderr| the
   program name, a colon and a space.  Otherwise, error will call this
   function without parameters instead.  */
extern void (*error_print_progname)(void);

/* This variable is incremented each time |error| is called.  */
extern unsigned int error_message_count;

/* Sometimes we want to have at most one error per line.  This
   variable controls whether this mode is selected or not.  */
extern int error_one_per_line;

#endif
