with Ada.Sequential_IO;
package Character_IO is
   package Character_IO is
      new Ada.Sequential_IO(Element_Type => Character);

   procedure Open  (File : in out Character_IO.File_Type;
                    Mode : in Character_IO.File_Mode;
                    Name : in String;
                    Form : in String := "") renames Character_IO.Open;
   procedure Create(File : in out Character_IO.File_Type;
                    Mode : in Character_IO.File_Mode := Character_IO.Out_File;
                    Name : in String := "";
                    Form : in String := "") renames Character_IO.Create;
   function End_Of_File(File : in Character_IO.File_Type) return Boolean
     renames Character_IO.End_Of_File;
   function Name   (File : in Character_IO.File_Type) return String
     renames Character_IO.Name;
   function Is_Open(File : in Character_IO.File_Type) return Boolean
     renames Character_IO.Is_Open;
   procedure Close (File : in out Character_IO.File_Type) renames Character_IO.Close;

   function Get_Line(File : in Character_IO.File_Type) return String;
   function Get_Line(File : in Character_IO.File_Type;
                     New_Line : out Boolean) return String;
   procedure Put_Line(File : in Character_IO.File_Type;
                      Item : in String;
                      New_Line : Boolean := True );
end Character_IO;
